#-*- coding: iso-8859-15 -*-

"""
[scramble.py]
Modulo que devuelve un algoritmo de desorden del cubo.
"""

__author__ = "Victor Ramirez de la Corte"
__date__ = "02/04/2009"
__version__ = "PyRubik v0.5"

import random 
from language import *

def estaEntre(m, n, *var):
    """var* esta entre los puntos m(inclusive) e n(no inclusive), m < n"""
    variables = var
    for v in variables:
        if m <= v and v < n:
            b = True
        else:
            b = False
            break 
    return b

class Scramble:
    """Clase que devuelve un algoritmo de desorden del cubo"""
    def scramble(self):
        """Función que devuelve un algoritmo de desorden del cubo"""
        #prevX--> X movimientos anteriores, Vinicial 100 para que no de errores
        prev1 = 100
        prev2 = 100
        #solStr, solList--> cadena solucion, lista solucion
        solStr = ""
        solList = []
        movs = lll.movs

        #bucle hasta conseguir 25 movimientos 
        while len(solList) < 25:
            rand = random.randint(0, 17)
            #hacemos que no repita misma cara
            if estaEntre(0, 3, rand, prev1) or estaEntre(3, 6, rand, prev1):
                pass
            elif estaEntre(6, 9, rand, prev1) or estaEntre(9, 12, rand, prev1):
                pass
            elif estaEntre(12,15,rand,prev1) or estaEntre(15, 18, rand, prev1):
                pass
            #evitamos cara + cara opuesta + cara
            elif estaEntre(0, 6, rand, prev1, prev2):
                pass
            elif estaEntre(6, 12, rand, prev1, prev2):
                pass
            elif estaEntre(12, 18, rand, prev1, prev2):
                pass
            else:
                prev2 = prev1
                prev1 = rand
                solList.append(movs[rand])
            
        for n in solList:
            solStr += n + " "

        return solStr
        



